public abstract class Binaire implements Expr{

    private Expr opg, opd;
    
    protected Binaire(Expr g, Expr d){
	this.opg = g;
	this.opd = d;
    }

    public Expr getOpg(){
	return opg;
    }

    public Expr getOpd(){
	return opd;
    }

    public double evaluer(Contexte c){
	return calculer (getOpg().evaluer(c),getOpd().evaluer(c));
    }

    public String decompiler(){
	return "("+getOpg().decompiler()+ getOp() + getOpd().decompiler() + ")";
    }
    
    public abstract String getOp();
    public abstract double calculer(double v1, double v2);
}
